#ifndef DISPred_RedSigmaPoint_h
#define DISPred_RedSigmaPoint_h
#include<iostream>

namespace DISPred  {
  class RedSigmaPoint {
    
  public:
    RedSigmaPoint(double q2, double x);
    RedSigmaPoint(double q2, double x,double redsigma);
    RedSigmaPoint(double q2, double x,double redsigma, double d2sdq2dx );
    RedSigmaPoint();
    ~RedSigmaPoint();

    double Q2(){return _q2;};
    double X(){return _x;};
    double RedSigma(){return _redsigma;};
    double D2sDQ2Dx(){return _d2sdq2dx;};
    void SetRedSigma(double reduced){_redsigma=reduced;};
    void SetD2sDQ2Dx(double reduced){_d2sdq2dx=reduced;};
    void Print(void);
    void PrintShort(void);


  private:

    double _q2;
    double _x;
    double _redsigma;
    double _d2sdq2dx;

    

  };
}




#endif
