#ifndef qcdnumjf_h
#define qcdnumjf_h

#include<TROOT.h>

extern "C" void qninit_();
extern "C" void grqinp_(Double_t&,Int_t&);
extern "C" void grxinp_(Double_t&,Int_t&);
extern "C" void grxlim_(Int_t&,Double_t&);
extern "C" void grqlim_(Int_t&,Double_t&,Double_t&);
extern "C" void grxdef_(Int_t&,Double_t&);
extern "C" void grqdef_(Int_t&,Double_t&,Double_t&);
extern "C" double qstfxq_(char*, char*, double&, double&, int&, long int, long int);
extern "C" void   qnlinc_(int&, char*, int&, double[], long int);
extern "C" void   qnbook_(int&, char*, long int);
extern "C" {
  void  openhelper_(int&, char*, long int);
  void  closehelper_(int&);
  void  writefile_(int&, char*, long int);
  void  qnvershelper_(bool&, int&, int&);
  void  f_init(); // for fortran I/O initialisation. Called in qninit
  void  f_exit(); // opposite of f_init
  double xfromix_(int&);
  int    iqfromq_(double&);
  int    nflget_(int&);             
  double qfromiq_(int&);  
  void   qnfilw_(int&, int&);
  void   qnpset_(char*, int&, int&, double&, long int);
  double qpdfxq_(char*, double&, double&, int&, long int);
  void   evolsg_(int&, int&, int&);
  void grxdef(int i, double x);
  void grqdef(int i, double x, double y);
  void   qnrset_(char*, double&, long int);
  void   evolnp_(char*, int&, int&, int&, long int);
  void   evolnm_(char*, int&, int&, int&, long int);
  void   evplus_(char*, int&, int&, int&, long int); //wrapper to write  
  void   qnlset_(char*, bool&, long int);
  void   qniset_(char*, int&, long int);
  void   qaddsi_(char*, int&, double&, long int);
  void   qnpnul_(char*, long int);  //wrapper to write
  void   qthres_(double&, double&);
  //  void   qndump_(int&);
  //  void  openhelper_(int&, char*, long int);
  //  void  closehelper_(int&);
  //  void  writefile_(int&, char*, long int);
  //  void  f_init(); // for fortran I/O initialisation. Called in qninit
  //  void  f_exit(); // opposite of f_init
}

void qnlinc(int i, std::string s, int j, double x[]){
  long int slen = s.length();
  const char * bob = s.c_str();
  char* c=new char[slen+1];
  strcpy(c,bob);
  qnlinc_(i, c, j, x, slen);
  delete[] c;
  return;
}


double qstfxq(std::string s,std::string t,Double_t x ,Double_t y,Int_t i){
  long int slen = s.length();
  long int tlen = t.length();
  const char * bob = s.c_str();
  const char * bub = t.c_str();
  char* c = new char[slen+1]; 
  char* d = new char[tlen+1];
  strcpy(c,bob);
  strcpy(d,bub);
  double result = qstfxq_(c, d, x, y, i, slen, tlen);
  delete[] c;
  delete[] d;
  //std::cout << result << std::endl;
  return result;
};


void qnbook(int i, std::string s){
  long int slen = s.length();
  const char * bob = s.c_str();
  char* c=new char[slen+1];
  strcpy(c,bob);
  qnbook_(i, c, slen);
  delete[] c;
  return;
}

// sucessfully tested? yes
void qnfilw(int i, int j){
  qnfilw_(i, j);
  return;
}


// sucessfully tested
void qnpset(std::string s, int i, int j, double x){
  long int slen = s.length();
  const char * bob = s.c_str();
  
  char* c = new char[slen+1];
  strcpy(c,bob);
  
  qnpset_(c, i, j, x, slen);
  
  delete[] c;
  return;
}


void qaddsi(std::string s, int i, double j){
  long int slen = s.length();
  const char * bob = s.c_str();
  char* c=new char[slen+1];
  strcpy(c,bob);
  qaddsi_(c, i, j ,slen);
  delete[] c;
  return;
}

double xfromix(int i){
  double x = xfromix_(i);
  return x;
}

// sucessfully tested? yes
int iqfromq(double x){
  int i = iqfromq_(x);
  return i;
}

// sucessfully tested? yes
int nflget(int x){
  int i = nflget_(x);
  return i;
}

//sucessfully tested
double qfromiq(int i){
  double q = qfromiq_(i);
  return q;
}

// sucessfully tested
double qpdfxq(std::string s, double x, double y, int & i){
  long int slen = s.length();
  const char * bob = s.c_str();
  char* c=new char[slen+1];
  strcpy(c,bob);
  double result = qpdfxq_(c, x, y, i, slen);
  delete[] c;
  return result;
}

// sucessfully tested
void evolsg(int i, int j, int k){
  evolsg_(i, j, k);
  return;
}

// sucessfully tested
void grxdef(int i, double x){
  grxdef_(i, x);
  return;
}

// sucessfully tested
void grqdef(int i, double x, double y){
  grqdef_(i, x, y);
  return;
}


// sucessfully tested
void qnrset(std::string s, double x){
  long int slen = s.length();
  const char * bob = s.c_str();
  char* c=new char[slen+1];
  strcpy(c,bob);
  qnrset_(c, x, slen);
  delete[] c;
  return;
}


void evolnp(std::string s, int i, int j, int k){
  long int slen = s.length();
  const char * bob = s.c_str();
  
  char* c = new char[slen+1];
  strcpy(c,bob);
  
  evolnp_(c, i, j, k, slen);
  
  delete[] c;
  return;
}

void evolnm(std::string s, int i, int j, int k){
  long int slen = s.length();
  const char * bob = s.c_str();
  
  char* c = new char[slen+1];
  strcpy(c,bob);
  
  evolnm_(c, i, j, k, slen);
  
  delete[] c;
  return;
}

//successfully tested
void evplus(std::string s, int i, int j, int k){
  long int slen = s.length();
  const char * bob = s.c_str();
  
  char* c = new char[slen+1];
  strcpy(c,bob);  

  evplus_(c, i, j, k, slen);

  delete[] c;
  return;
}

void qnlset(std::string s, bool l){
  long int slen = s.length();
  const char * bob = s.c_str();
  char* c=new char[slen+1];
  strcpy(c,bob);
  qnlset_(c, l, slen);
  delete[] c;
  return;
}

void qniset(std::string s, int i){
  long int slen = s.length();
  const char * bob = s.c_str();
  char* c=new char[slen+1];
  strcpy(c,bob);
  qniset_(c, i, slen);
  delete[] c;
  return;
}

/*
void openFileWithLun(int lun, std::string filename){
  long int namelen = filename.length();
  const char * bob = filename.c_str();
  char* c=new char[namelen+1];
  strcpy(c,bob);
  
  openhelper_(lun, c, namelen);
  
  delete[] c;
  return;
}

*/
//void qndump(int lun){
//  qndump_(lun);
//  return;
//}

void grqinp(double x, int i){
  grqinp_(x, i);
  return;
}

void grxinp(double x, int i){
  grxinp_(x, i);
  return;
}

void qthres(double x, double y){
  qthres_(x, y);
  return;
}



#endif
